Loading...
Searching...
No Matches
RowTimeBlockEncoder Class Reference

`#include <rowtimeblockencoder.h>`

## Public Member Functions

| RowTimeBlockEncoder (size_t nPol, size_t nChannels)
virtual | ~RowTimeBlockEncoder () override
virtual void | EncodeWithDithering (const dyscostman::StochasticEncoder< float > &gausEncoder, FBuffer &buffer, float *metaBuffer, symbol_t *symbolBuffer, size_t antennaCount, std::mt19937 &rnd) final override
virtual void | EncodeWithoutDithering (const dyscostman::StochasticEncoder< float > &gausEncoder, FBuffer &buffer, float *metaBuffer, symbol_t *symbolBuffer, size_t antennaCount) final override
virtual void | InitializeDecode (const float *metaBuffer, size_t nRow, size_t nAntennae) final override
virtual void | Decode (const dyscostman::StochasticEncoder< float > &gausEncoder, FBuffer &buffer, const symbol_t *symbolBuffer, size_t blockRow, size_t antenna1, size_t antenna2) final override
virtual size_t | SymbolCount (size_t nRow, size_t nPol, size_t nChannels) const final override
virtual size_t | SymbolCount (size_t nRow) const final override
virtual size_t | SymbolsPerRow () const final override
virtual size_t | MetaDataCount (size_t nRow, size_t, size_t, size_t) const final override
Public Member Functions inherited from TimeBlockEncoder
virtual | ~TimeBlockEncoder ()

## Private Member Functions

template<bool UseDithering>
void | encode (const dyscostman::StochasticEncoder< float > &gausEncoder, const FBuffer &buffer, float *metaBuffer, symbol_t *symbolBuffer, size_t antennaCount, std::mt19937 *rnd)

## Private Attributes

size_t | _nPol
size_t | _nChannels
std::uniform_int_distribution< unsigned > | _ditherDist
aocommon::UVector< double > | _rowFactors

## Additional Inherited Members

Public Types inherited from TimeBlockEncoder
typedef TimeBlockBuffer< std::complex< float > > | FBuffer
typedef TimeBlockBuffer< std::complex< float > >::DataRow | FBufferRow
typedef TimeBlockBuffer< std::complex< double > > | DBuffer
typedef TimeBlockBuffer< std::complex< double > >::DataRow | DBufferRow
typedef unsigned | symbol_t
Protected Member Functions inherited from TimeBlockEncoder
| TimeBlockEncoder ()

## Detailed Description

Definition at line 14 of file rowtimeblockencoder.h.

## Constructor & Destructor Documentation

## RowTimeBlockEncoder()

RowTimeBlockEncoder::RowTimeBlockEncoder | ( | size_t | nPol,
|  | size_t | nChannels )

## ~RowTimeBlockEncoder()

virtual RowTimeBlockEncoder::~RowTimeBlockEncoder | ( |  | ) |

inline override virtual

Definition at line 18 of file rowtimeblockencoder.h.

## Member Function Documentation

## Decode()

virtual void RowTimeBlockEncoder::Decode | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | FBuffer & | buffer,
|  | const symbol_t * | symbolBuffer,
|  | size_t | blockRow,
|  | size_t | antenna1,
|  | size_t | antenna2 )

final override virtual

Implements TimeBlockEncoder.

## encode()

template<bool UseDithering>

void RowTimeBlockEncoder::encode | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | const FBuffer & | buffer,
|  | float * | metaBuffer,
|  | symbol_t * | symbolBuffer,
|  | size_t | antennaCount,
|  | std::mt19937 * | rnd )

private

Referenced by EncodeWithDithering(), and EncodeWithoutDithering().

## EncodeWithDithering()

virtual void RowTimeBlockEncoder::EncodeWithDithering | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | FBuffer & | buffer,
|  | float * | metaBuffer,
|  | symbol_t * | symbolBuffer,
|  | size_t | antennaCount,
|  | std::mt19937 & | rnd )

inline final override virtual

Implements TimeBlockEncoder.

Definition at line 20 of file rowtimeblockencoder.h.

References encode().

## EncodeWithoutDithering()

virtual void RowTimeBlockEncoder::EncodeWithoutDithering | ( | const dyscostman::StochasticEncoder< float > & | gausEncoder,
|  | FBuffer & | buffer,
|  | float * | metaBuffer,
|  | symbol_t * | symbolBuffer,
|  | size_t | antennaCount )

inline final override virtual

Implements TimeBlockEncoder.

Definition at line 28 of file rowtimeblockencoder.h.

References encode().

## InitializeDecode()

virtual void RowTimeBlockEncoder::InitializeDecode | ( | const float * | metaBuffer,
|  | size_t | nRow,
|  | size_t | nAntennae )

final override virtual

Implements TimeBlockEncoder.

## MetaDataCount()

virtual size_t RowTimeBlockEncoder::MetaDataCount | ( | size_t | nRow,
|  | size_t | ,
|  | size_t | ,
|  | size_t | ) const

inline final override virtual

Implements TimeBlockEncoder.

Definition at line 57 of file rowtimeblockencoder.h.

## SymbolCount() [1/2]

virtual size_t RowTimeBlockEncoder::SymbolCount | ( | size_t | nRow | ) | const

inline final override virtual

Implements TimeBlockEncoder.

Definition at line 49 of file rowtimeblockencoder.h.

References _nChannels, and _nPol.

## SymbolCount() [2/2]

virtual size_t RowTimeBlockEncoder::SymbolCount | ( | size_t | nRow,
|  | size_t | nPol,
|  | size_t | nChannels ) const

inline final override virtual

Implements TimeBlockEncoder.

Definition at line 44 of file rowtimeblockencoder.h.

## SymbolsPerRow()

virtual size_t RowTimeBlockEncoder::SymbolsPerRow | ( |  | ) | const

inline final override virtual

Implements TimeBlockEncoder.

Definition at line 53 of file rowtimeblockencoder.h.

References _nChannels, and _nPol.

## Member Data Documentation

## _ditherDist

std::uniform_int_distribution<unsigned> RowTimeBlockEncoder::_ditherDist

private

Definition at line 71 of file rowtimeblockencoder.h.

## _nChannels

size_t RowTimeBlockEncoder::_nChannels

private

Definition at line 69 of file rowtimeblockencoder.h.

Referenced by SymbolCount(), and SymbolsPerRow().

## _nPol

size_t RowTimeBlockEncoder::_nPol

private

Definition at line 69 of file rowtimeblockencoder.h.

Referenced by SymbolCount(), and SymbolsPerRow().

## _rowFactors

aocommon::UVector<double> RowTimeBlockEncoder::_rowFactors

private

Definition at line 72 of file rowtimeblockencoder.h.

The documentation for this class was generated from the following file:

- tables/Dysco/rowtimeblockencoder.h